vms_data.ads: Fix typo in constant.
[gcc.git] / libstdc++-v3 / scripts / run_doxygen
1 #!/bin/bash
2
3 # Runs doxygen and massages the output files.
4 # Copyright (C) 2001, 2002, 2003, 2004, 2008 Free Software Foundation, Inc.
5 #
6 # Synopsis: run_doxygen --mode=[html|man|xml] --host_alias=<alias> \
7 # v3srcdir v3builddir
8 #
9 # Originally hacked together by Phil Edwards <pme@gcc.gnu.org>
10
11
12 # We can check now that the version of doxygen is >= this variable.
13 DOXYVER=1.5.1
14
15 find_doxygen() {
16 local -r v_required=`echo $DOXYVER | \
17 awk -F. '{if(NF<3)$3=0;print ($1*100+$2)*100+$3}'`
18 local testing_version doxygen maybedoxy v_found
19 # thank you goat book
20 set `IFS=:; X="$PATH:/usr/local/bin:/bin:/usr/bin"; echo $X`
21 for dir
22 do
23 # AC_EXEEXT could come in useful here
24 maybedoxy="$dir/doxygen"
25 test -f "$maybedoxy" && testing_version=`$maybedoxy --version`
26 if test -n "$testing_version"; then
27 v_found=`echo $testing_version | \
28 awk -F. '{if(NF<3)$3=0;print ($1*100+$2)*100+$3}'`
29 if test $v_found -ge $v_required; then
30 doxygen="$maybedoxy"
31 break
32 fi
33 fi
34 done
35 if test -z "$doxygen"; then
36 echo run_doxygen error: Could not find Doxygen $DOXYVER in path. 1>&2
37 print_usage
38 fi
39 # We need to use other tools from the same package/version.
40 echo :: Using Doxygen tools from ${dir}.
41 PATH=$dir:$PATH
42 hash -r
43 }
44
45 print_usage() {
46 cat 1>&2 <<EOF
47 Usage: run_doxygen --mode=MODE --host_alias=BUILD_ALIAS [<options>]
48 <v3-src-dir> <v3-build-dir>
49 MODE is one of:
50 html Generate user-level HTML library documentation.
51 man Generate user-level man pages.
52 xml Generate user-level XML pages.
53
54 BUILD_ALIAS is the GCC build alias set at configure time.
55
56 Note: Requires Doxygen ${DOXYVER} or later; get it at
57 ftp://ftp.stack.nl/pub/users/dimitri/doxygen-${DOXYVER}.src.tar.gz
58
59 EOF
60 exit 1
61 }
62
63 parse_options() {
64 for o
65 do
66 # Blatantly ripped from autoconf, er, I mean, "gratefully standing
67 # on the shoulders of those giants who have gone before us."
68 case "$o" in
69 -*=*) arg=`echo "$o" | sed 's/[-_a-zA-Z0-9]*=//'` ;;
70 *) arg= ;;
71 esac
72
73 case "$o" in
74 --mode=*)
75 mode=$arg ;;
76 --host_alias=*)
77 host_alias=$arg ;;
78 --mode | --host_alias | --help | -h)
79 print_usage ;;
80 *)
81 # this turned out to be a mess, maybe change to --srcdir=, etc
82 if test $srcdir = unset; then
83 srcdir=$o
84 elif test $outdir = unset; then
85 builddir=${o}
86 outdir=${o}/doc/doxygen
87 else
88 echo run_doxygen error: Too many arguments 1>&2
89 exit 1
90 fi
91 ;;
92 esac
93 done
94 }
95
96
97 # script begins here
98 mode=unset
99 host_alias=unset
100 srcdir=unset
101 outdir=unset
102 do_html=false
103 do_man=false
104 do_xml=false
105 enabled_sections=
106 generate_tagfile=
107 DATEtext=`date '+%Y-%m-%d'`
108
109 # Show how this script is called.
110 echo run_doxygen $*
111
112 parse_options $*
113 find_doxygen
114
115 if test $srcdir = unset || test $outdir = unset || test $mode = unset || test $host_alias = unset; then
116 # this could be better
117 echo run_doxygen error: You have not given enough information...! 1>&2
118 print_usage
119 fi
120
121 case x"$mode" in
122 xhtml)
123 do_html=true
124 enabled_sections=maint
125 generate_tagfile="$outdir/html/libstdc++.tag"
126 ;;
127 xman)
128 do_man=true
129 ;;
130 xxml)
131 do_xml=true
132 enabled_sections=maint
133 ;;
134 *)
135 echo run_doxygen error: $mode is an invalid mode 1>&2
136 exit 1 ;;
137 esac
138
139 mkdir -p $outdir
140 chmod u+w $outdir
141
142 # work around a stupid doxygen bug
143 if $do_man; then
144 mkdir -p $outdir/man/man3/ext
145 chmod -R u+w $outdir/man/man3/ext
146 fi
147
148 if $do_xml; then
149 mkdir -p $outdir/xml
150 fi
151
152 (
153 set -e
154 cd $builddir
155 sed -e "s=@outdir@=${outdir}=g" \
156 -e "s=@srcdir@=${srcdir}=g" \
157 -e "s=@builddir@=${builddir}=g" \
158 -e "s=@host_alias@=${host_alias}=g" \
159 -e "s=@enabled_sections@=${enabled_sections}=" \
160 -e "s=@do_html@=${do_html}=" \
161 -e "s=@do_man@=${do_man}=" \
162 -e "s=@do_xml@=${do_xml}=" \
163 -e "s=@generate_tagfile@=${generate_tagfile}=" \
164 ${srcdir}/doc/doxygen/user.cfg.in > ${outdir}/${mode}.cfg
165 echo :: NOTE that this may take some time...
166 echo doxygen ${outdir}/${mode}.cfg
167 doxygen ${outdir}/${mode}.cfg
168 echo :: Finished, exit code was $?
169 )
170 ret=$?
171 test $ret -ne 0 && exit $ret
172
173 if $do_html; then
174 cd ${outdir}/html
175
176 #doxytag -t libstdc++.tag . > /dev/null 2>&1
177 sed -e '/<path>/d' libstdc++.tag > TEMP
178 mv TEMP libstdc++.tag
179
180 sed -e "s=@DATE@=${DATEtext}=" \
181 ${srcdir}/doc/doxygen/mainpage.html > index.html
182
183 # The following bit of line noise changes annoying
184 # std::foo < typename _Ugly1, typename _Ugly2, .... _DefaultUgly17 >
185 # to user-friendly
186 # std::foo
187 # in the major "Compound List" page.
188 sed -e 's=\(::[[:alnum:]_]*\)&lt; .* &gt;=\1=' annotated.html > annstrip.html
189 mv annstrip.html annotated.html
190
191 # Work around a bug in doxygen 1.3.
192 # for f in class*html struct*html; do
193 for f in class*html; do
194 sed '1,10s!^<title> Template!<title>Template !' $f > TEMP
195 mv TEMP $f
196 done
197
198 cp ${srcdir}/doc/doxygen/tables.html tables.html
199 echo ::
200 echo :: HTML pages begin with
201 echo :: ${outdir}/html/index.html
202 fi
203
204 # Mess with the man pages. We don't need documentation of the internal
205 # headers, since the man pages for those contain nothing useful anyhow. The
206 # man pages for doxygen modules need to be renamed (or deleted). And the
207 # generated #include lines need to be changed from the internal names to the
208 # standard ones (e.g., "#include <stl_tempbuf.h>" -> "#include <memory>").
209 if $do_man; then
210 echo ::
211 echo :: Fixing up the man pages...
212 cd $outdir/man/man3
213
214 # here's the other end of the "stupid doxygen bug" mentioned above
215 rm -rf ext
216
217 # File names with embedded spaces (EVIL!) need to be....? renamed or removed?
218 find . -name "* *" -print0 | xargs -0r rm # requires GNU tools
219
220 # can leave SGIextensions.3 alone, it's an okay name
221 mv s20_3_1_base.3 Intro_functors.3
222 mv s20_3_2_arithmetic.3 Arithmetic_functors.3
223 mv s20_3_3_comparisons.3 Comparison_functors.3
224 mv s20_3_4_logical.3 Logical_functors.3
225 mv s20_3_5_negators.3 Negation_functors.3
226 #mv s20_3_6_binder.3 Binder_functors.3
227 mv s20_3_7_adaptors.3 Func_ptr_functors.3
228 mv s20_3_8_memadaptors.3 Member_ptr_functors.3
229 mv iterator_tags.3 Iterator_types.3
230 mv std.3 Namespace_std.3
231 mv __gnu_cxx.3 Namespace___gnu_cxx.3
232
233 # man pages are for functions/types/other entities, not source files
234 # directly. who the heck would type "man foo.h" anyhow?
235 find . -name "[a-z]*" -a ! -name "std_*" -print | xargs rm
236 rm -f *.h.3 *config* *.cc.3 *.tcc.3 *_t.3
237 # this is used to examine what we would have deleted, for debugging
238 #mkdir trash
239 #find . -name "[a-z]*" -a ! -name "std_*" -print | xargs -i mv {} trash
240 #mv *.h.3 *config* *.cc.3 *.tcc.3 *_t.3 trash
241
242 # Standardize the displayed header names. If anyone who knows perl cares
243 # enough to rewrite all this, feel free. This only gets run once a century,
244 # and I'm off getting coffee then anyhow, so I didn't care enough to make
245 # this super-fast.
246 g++ ${srcdir}/doc/doxygen/stdheader.cc -o ./stdheader
247 problematic=`egrep -l '#include <.*_.*>' [a-z]*.3`
248 for f in $problematic; do
249 # this is also slow, but safe and easy to debug
250 oldh=`sed -n '/fC#include </s/.*<\(.*\)>.*/\1/p' $f`
251 newh=`echo $oldh | ./stdheader`
252 sed "s=${oldh}=${newh}=" $f > TEMP
253 mv TEMP $f
254 done
255 rm stdheader
256
257 # Some of the pages for generated modules have text that confuses certain
258 # implementations of man(1), e.g., Linux's. We need to have another top-level
259 # *roff tag to /stop/ the .SH NAME entry.
260 #problematic=`egrep --files-without-match '^\.SH SYNOPSIS' [A-Z]*.3`
261 problematic='Containers.3 Sequences.3 Assoc_containers.3 Iterator_types.3'
262 for f in $problematic; do
263 sed '/^\.SH NAME/{
264 n
265 a\
266 \
267 .SH SYNOPSIS
268 }' $f > TEMP
269 mv TEMP $f
270 done
271
272 # Also, break this (generated) line up. It's ugly as sin.
273 problematic=`grep -l '[^^]Definition at line' *.3`
274 for f in $problematic; do
275 sed 's/Definition at line/\
276 .PP\
277 &/' $f > TEMP
278 mv TEMP $f
279 done
280
281 cp ${srcdir}/doc/doxygen/Intro.3 C++Intro.3
282
283 # Why didn't I do this at the start? Were rabid weasels eating my brain?
284 # Who the fsck would "man std_vector" when the class isn't named that?
285
286 # First, deal with nested namespaces.
287 for f in *__detail_*; do
288 newname=`echo $f | sed 's/__detail_/__detail::/'`
289 mv $f $newname
290 done
291 for f in *__parallel_*; do
292 newname=`echo $f | sed 's/__parallel_/__parallel::/'`
293 mv $f $newname
294 done
295
296 # Then, clean up other top-level namespaces.
297 for f in std_tr1_*; do
298 newname=`echo $f | sed 's/^std_tr1_/std::tr1::/'`
299 mv $f $newname
300 done
301 for f in std_*; do
302 newname=`echo $f | sed 's/^std_/std::/'`
303 mv $f $newname
304 done
305 for f in __gnu_cxx_*; do
306 newname=`echo $f | sed 's/^__gnu_cxx_/__gnu_cxx::/'`
307 mv $f $newname
308 done
309 for f in __gnu_debug_*; do
310 newname=`echo $f | sed 's/^__gnu_debug_/__gnu_debug::/'`
311 mv $f $newname
312 done
313 for f in __gnu_parallel_*; do
314 newname=`echo $f | sed 's/^__gnu_parallel_/__gnu_parallel::/'`
315 mv $f $newname
316 done
317
318 # Generic removal bits, where there are things in the generated man
319 # pages that need to be killed.
320 for f in *_libstdc__-v3_*; do
321 rm $f
322 done
323
324 for f in *_src_*; do
325 rm $f
326 done
327
328
329 # Also, for some reason, typedefs don't get their own man pages. Sigh.
330 for f in ios streambuf istream ostream iostream stringbuf \
331 istringstream ostringstream stringstream filebuf ifstream \
332 ofstream fstream string;
333 do
334 echo ".so man3/std::basic_${f}.3" > std::${f}.3
335 echo ".so man3/std::basic_${f}.3" > std::w${f}.3
336 done
337
338 echo ::
339 echo :: Man pages in ${outdir}/man
340 fi
341
342 # all done
343 echo ::
344
345 exit 0